package it.polito.po.test;

import java.util.Collection;
import java.util.Iterator;
import junit.framework.TestCase;
import hospital.*;

public class Test4_ListOfPatients extends TestCase {

	public Test4_ListOfPatients(String name) {
		super(name);
	}

	Hospital h;
	
	protected void setUp() throws Exception {
		h = new Hospital();
	}

	public void testList() throws NoSuchPatient, NoSuchDoctor {
			String ssn1 = "THEPID12I99F181K";
			h.addPatient("Giova","Reds", ssn1);

			String ssn2 = "BLKSRS11I88F981K";
			h.addPatient("Sirius","Black", ssn2);

			int docID = 5;
			String dfirst = "Mario";
			String dlast = "White";
			h.addDoctor(dfirst, dlast, docID);
			
			h.assignPatientToDoctor(ssn1, docID);
			h.assignPatientToDoctor(ssn2, docID);
			
			Person p1 = h.getPatient(ssn1);
			Person p2 = h.getPatient(ssn2);			
			
			Collection<Person> patients = h.getDoctor(docID).getPatients();
			
		    assertTrue(patients.contains(p1));
			assertTrue(patients.contains(p2));
	  }
	  
	  public void testOrderedList() throws NoSuchPatient, NoSuchDoctor {
			String ssn1 = "THEPID12I99F181K";
			h.addPatient("Giova","Red", ssn1);
			String ssn2 = "BLKSRS11I88F981K";
			h.addPatient("Sirius","Black", ssn2);
			String ssn3 = "RSSPLA13I88F981K";
			h.addPatient("Paolo","White", ssn3);

			int docID = 5;
			String dfirst = "Mario";
			String dlast = "White";
			h.addDoctor(dfirst, dlast, docID);

			h.assignPatientToDoctor(ssn1, docID);
			h.assignPatientToDoctor(ssn2, docID);
			h.assignPatientToDoctor(ssn3, docID);
			
			Collection<Person> patients = h.getDoctor(docID).getPatients();
			Iterator<Person> it = patients.iterator();
			
	  		Person p1 = (Person)it.next();
			Person p2 = (Person)it.next();
			Person p3 = (Person)it.next();
			
			assertEquals("Red",p1.getLast());
			assertEquals("Black",p2.getLast());
			assertEquals("White",p3.getLast());
			assertEquals("Paolo",p3.getFirst());
	  }
}